
 /* ModeReq V37.83                                             */
 /* FREEWARE.                                                  */
 /* (c) 1993 by Andreas R. Kleinert.                           */
 /* Demonstrates use of the "ak_gen0.library"'s ModeRequester. */
 /* (using the extended Requester-Functions of V37+)           */
 /* Also opening of windows is demonstrated.                   */
 /* Written in SAS/C V6.00 for OS V2.04 (V37) Includes.        */

#include <ak_gen0/ak_gen0_pragma.h>

#include <stdlib.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>

void main(long argc, char **argv) /* MAIN */
{
 struct Window       *tst_win = N;
 struct AK_ModeEntry *me_ptr  = N;

 IntuitionBase = (struct IntuitionBase *) OpenLibrary("intuition.library", 0);

  /* will always be open because of version==0 */

 printf("\nModeReq V37.83, FREEWARE, (c) 1993 by Andreas R. Kleinert.\n");

 AKBase = (struct AKBase *) OpenLibrary("ak_gen0.library", 37); /* minimum */
 if(AKBase)
  {
   tst_win = AK_Window( 0, 0, 640, 256, 1, 2, N, (ACTIVATE|WINDOWSIZING|NOCAREREFRESH|SIMPLE_REFRESH), N, N, "Test-Window", N, N, 640, 256, 640, 256, WBENCHSCREEN);
   if(tst_win)
    {
     struct AK_Requester *ak_req = N;

     ak_req = AK_AllocRequester(AK_REQTYPE_MODE);  /* Allocate Requester */
     if(ak_req)
      {
       ak_req->akr_Window     = CURRENT_WINDOW; /* optional */
       ak_req->akr_OKText     = " Take ";       /* optional */
       ak_req->akr_CancelText = " Quit ";       /* optional */
       ak_req->akr_LeftEdge   = 75;             /* optional */
       ak_req->akr_TopEdge    = 25;             /* optional */

       me_ptr = AK_ModeRequest(ak_req);
       if(me_ptr)
        {
         printf("\n Selected Mode is %s (%ldx%ld, %ld Colors).\n", 
          me_ptr->ModeName, me_ptr->MaxWidth, me_ptr->MaxHeight, 1<<me_ptr->MaxDepth);

         FreeMem(me_ptr, me_ptr->Length);
        }else
        {
         printf("\n No Mode selected.\n");
        }

       AK_FreeRequester(ak_req);                    /* Free Requester */
      }

     CloseWindow(tst_win);
    }

   CloseLibrary((APTR) AKBase);
  }else
  {
   printf("\n Can't open \42ak_gen0.library\42 V37+ !\n");
  }

 CloseLibrary((APTR) IntuitionBase);

 exit(0);
}
